Contents

DP4 for Windows Installation Guide

This guide tells you how to install and configure DP4 for 32-bit and 64-bit Microsoft Windows. If you are installing 4.621 or a later release of DP4 on a machine with DP4 already installed and you use the DP4 installation program then you do not really need to read this guide, because the installation program will preserve existing information when you install a new release of DP4 over your existing installation.

  1. Please check the Requirements page before attempting to install DP4.

  2. If you are installing on a 64-bit version of Windows or on a version of Windows later than Windows XP then check the Platform Specific Considerations page before attempting to install DP4.

  3. The installation procedure may be slightly different if you are running a version of Windows with a Citrix product such as Winrame or Metaframe installed, or on NT Terminal Server edition, or Windows 2000 or later with Terminal Services installed. In case of doubt please refer to the second link below.
    • Installing DP4 for Windows (For most 32-bit and 64-bit versions of Windows except for Windows CE versions)
    • Installing DP4 for Windows on Citrix Winframe and NT Terminal Servers

This guide does not cover installing DP4 on Windows CE devices. Please refer to DP4 for Windows CE, on the Itim DP4 Web site for information about installing DP4 on Windows CE.

In release 4.621 there were a number of changes to DP4 installation. You can read a summary of the changes in Changes to DP4 Installation for release 4.621.


What's New in the DP4 for Windows Installation Guide

This page will tell you about recent changes to this manual. The most recent changes are mentioned first.

New in 4.624

  • 2 Oct 2009 All information pertaining to Windows 3.x has been removed, and information about installing DP4 on 64-bit bit versions of Windows has been added.

New in 4.621

  • 6 Feb 2004 There are significant changes to the DP4 Installer in release 4.621. You can read a summary of the changes in Changes to DP4 installation for Release 4.621.

  • 2 Oct 2003 Re-arranged to eliminate unnecessary duplication of material, and Configuration section updated.

New in 4.620

  • 17 Oct 2002 What's New Page added

  • 08 Apr 2002 References to datafit.ini changed to "DP4 configuration file" throughout, and instructions updated to include DP4 Enterprise throughout.

New in 4.619

  • 7 Jun 2001 Additional information on installing for Windows 2000 with Terminal Services added


Changes to DP4 Installation from 4.621

There are significant changes to DP4 installation as of release 4.621. The changes are designed to make the DP4 installer easier to use and to prevent incorrect installation.

  • Upgrade installation of the base DP4 set is now accomplished by selecting the "Base DP4 for Windows" product. This includes all the files that would be installed when making an initial installation, but with the following changes:

    • Where possible DP4 configuration files are not replaced, but upgraded by applying necessary changes to the currently installed files.
    • When the system database is installed information user and printer information from the old system database is automatically preserved. Also the system database name is reset to SYSTEM to ensure the new system database is used.
  • The base DP4 program set now includes SQL (but not the ODBC driver), and two ADCs useful in analysing problems: AUXDEBUG and AUXDUPE. On the other hand files only required for supporting 16 bit applications are no longer installed as part of the base product, but are available in the "Interface to DP4 for Legacy Applications" product. This includes support for both MS-DOS and 16 bit Windows applications.
  • There is no longer any prompt before databases are over-written.

  • Additional components, such as C Programming Support, that previously required several related components to be installed, are now installed as a single component. A new Details... button allows you to select which sub-components of such components to install. The interface is similar to the Add/Remove Windows Components in Control Panel, except that the DP4 installer does not remove products that were already installed but are not selected for installation again.

  • Aspects of installation such as creating short-cuts in the start menu are now handled using "HTML applications". This allows the installer to provide considerably more sophisticated functionality in this area. You are recommended to allow the installer to create a start menu for DP4 when upgrading to 4.621.


Installing DP4 for Windows : Requirements

Supported Versions of Windows

32-bit Windows versions

Windows 95 or Windows NT 4 (or later) must be installed and running on your machine. 32-bit DP4 does not run on Windows 3.x, and version 4.616 onwards do not run Windows NT 3.5 or earlier. We no longer test DP4 on any version of Windows prior to Windows 2000. However, release 4.622 was tested on Windows NT 4 and Windows 9x machines, and so far as we know the latest release (4.624) would also run.

64-bit Windows versions

If you are running a 64-bit version of Windows then you must install DP4 4.624 or a later release. You can install either the 32-bit or the 64-bit release of DP4. As yet DP4 has only been tested on Windows 2008, but should work equally well on Windows 2003. We are not sure about Windows XP 64-bit edition

Disk Space Required

  • Approximately 10 Mbytes of disk space are required to install the 32-bit Base DP4 System, which comprises the DP4 programs plus System and Base Dictionary databases. The 64-bit version of DP4 requires around 13 Mbytes. On the disk where DP4 databases are to be stored you should aim to have a disk with sufficient space to hold at least 3 copies of the largest database you plan to work with.

Web Browser

  • To access the DP4 help files you need to have Microsoft Internet Explorer 5 or later installed. All the help files are available on the DP4 web site and work with any standards compliant web browser.


Platform Specific Considerations

Although installation of DP4 for Windows is very similar whatever releases of DP4 and Windows you are using there are few key points to bear in mind

Installing DP4 on 64-bit Windows

There are essentially no differences in the procedure for installing 32-bit DP4 or 64-bit DP4 using the DP4 install program. However, if you plan to install on a system running a 64 bit version of Windows then you must install 4.624 or a later release, because 4.623 and earlier do not work. The DP4 install program will adjust the list of components that are offered for installation according to whether you are installing on a 32-bit or a 64-bit operating systems. On 64-bit versions of Windows you can install either the regular 32-bit version of DP4 or the 64-bit version. If you install the 32-bit version of DP4 you can choose to install a component that will also allow 64-bit applications to run. If you install the 64-bit version of DP4 32-bit compatibility is included with the base installation. You can run any mix of 32-bit and 64-bit DP4 components as part of one installation provided they come from the same release. Note that when you install the 64-bit version of DP4 any file name that has "w32" as either part of the name or the extension in the win32 version has "w64" in the name instead. Also the 64-bit version of any DLL that has a name like xxxlibt.dll in the 32 bit version of DP4 has a name like xxxw64t.dll in the 64-bit version of DP4. This is to allow 32-bit and 64-bit executables to co-exist in the same DP4 installation.

Installing DP4 on Windows Vista, and Windows Server 2003 or later

If you are installing on Windows Server 2003, or Windows Vista or later, and you plan to run DP4 as a service, then you will probably want to add the component DP4TRAY.EXE to the startup group, because otherwise you will not be able to control the DP4 service from the taskbar notification area. This is because DP4 has traditionally run as an interactive service, but in these versions of Windows services are not allowed to interact with the desktop of ordinary users.


Installing DP4 for Windows

This guide tells you how to install and configure DP4 release 4.5xx or 4.6xx for 32-bit or 64-bit Windows. You should always logon with an account with local administrator privileges when installing DP4

We recommend that you use the DP4 install program to install DP4, because although you can install the software manually, as described in Appendix A, manual installation takes longer and is error prone.

If you are installing DP4 software for the first time, or you are installing 4.621 or a later release of DP4 over an existing DP4 installation, the DP4 install program will help you install successfully. To do this, follow the procedure described in Installing DP4 using the DP4 Install Program.

If you are upgrading from a previous release of DP4 but are using 4.620 or an earlier release, follow the procedure described in Upgrading an Existing Installation.

If you want to install additional DP4 components or to re-install individual components of the base system installation, follow the procedure in Installing Additional Products.

Once you have completed the initial DP4 installation you should follow the steps outlined in Configuration of DP4 on Windows.


Installation Using the DP4 Install Program

Installing DP4 Using the DP4 Install Program

For installation you need the following to hand:

  • The DP4 issue CD-ROM which contains DP4 Windows programs & System and Base Dictionary databases, or Zip files for the DP4 release you plan to use and the DP4 documentation.
  • Licence file disk (only needed for an initial installation)

Follow this procedure to install the DP4 software:

  1. Either:

    1. Insert the CD-ROM into the CD-ROM drive. The CD-ROM should start automatically, but its behaviour will depend on when the CD was created.

      • From release 4.621 (Feb 2004) the DP4 CD-ROM the auto-install program will run an HTML application that allows you to select which release of DP4 to install, or access documentation relating to DP4 installation. If this application is unable to run for some reason (for example because Internet Explorer 5 is not installed), but a web browser is installed a web page with similar functionality is launched, though some web browsers will not allow you to run applications from a web page. If all else fails the install program for the latest DP4 release will be started.

      • For older CDs, containing releases up to 4.620 the CD will usually default to installing the latest fully tested version of DP4 on the CD. The install program is available for other any other releases of DP4 on the CD as well and can be accessed by right clicking on the icon for your CD ROM drive in "My Computer", or by launching the install program from the appropriate directory.

    or:
    2. Unzip the Zip file for the release of DP4 you plan to install (e.g. 623.zip) and the DP4 documentation (docs.zip) into the same directory, but preserving the pathnames stored in the Zip files. If you have done this correctly, the directory you have unzipped the files to will contain setup.exe, a directory called Docs_DP4, and a directory with the same name as the ZIP file you downloaded and various subdirectories within this such as win32 or win64, src. Then start setup.exe, or navigate to the directory containing the install.exe program and start that. If

    If you have multiple copies of DP4 installed already on the machine you are installing onto, then you may prefer to start the install program from a command prompt which is logged to the directory containing the DP4 installation to be upgraded.

  2. The DP4 Windows Installation screen displays details about the version that will be installed. Read this information about the base system installation. The screen also contains three buttons:

    Install

    Clicking on the Install button takes you to dialogs that allow you to choose the DP4 components to be installed. Different screens are presented depending on whether or not an existing DP4 installation is detected.

    Help

    Accesses this installation manual

    Abort

    Returns you to Windows if you decide not to proceed with the installation. Note, that this initial screen is redisplayed after installation of one or more DP4 components has completed. In this case, from release 4.620, the Abort button is replaced by an Exit button.With older releases the button is still labelled Abort, but it functions as an Exit button.

  3. Click on the Install button.

    • If DP4 is not already installed, or is not detected, a dialog box appears specifying the default names of the base system directories:

      Windows directory

      Up to release 4.619 the DP4 configuration file (then called DATAFIT.INI) was always installed in the Windows directory, (usually C:\WINDOWS or C:\WINNT or similar). You cannot change this directory. No DP4 components are installed in any Windows directories any more.

      C:\DP4\WIN

      DP4 Windows NT programs and the DP4 licence file (DP4.SYS). After installation, you may change the location of the DP4 licence file, DP4 utilities and your own DP4 programs, but you cannot move the other files without reinstalling DP4.

      C:\DP4\DB

      Database data files (System and Base Dictionary)

      C:\DP4\DB

      Database index files (System and Base Dictionary)

      You may specify your own directories for all except for the first. If they do not already exist, the install program will create them for you.

      If you want to move the DP4 licence file to a separate directory after running the installation, you can do so as described in the DP4 Licence File

    • If DP4 is already installed, and is sucessfully recognised, you will instead be offered a list of products that can be installed. (See Installing additional products). To update the base DP4 set select the following components:

      • For release 4.619 or earlier: Ini files,Windows 95 & NT Programs, Base Dictionary database, System database.
      • For release 4.620: configuration files,Windows 9x/NT or later Programs, Base Dictionary database, System database.

      • for release 4.621: Base DP4 for Windows 9x/NT or later. (In fact you can usually accept the default options, which will install the most commonly used DP4 components)

      If you are attempting to install additional products, and have already installed DP4, but it is not detected, try running the install program from a command prompt logged to the directory where your DP4 programs are installed. In this case you will need to specify the full path to the install program, for example d:\620\win32\install

  4. Click on the OK button to install the software in the specified directories.

  5. When all the files have copied, the install program will ask you some questions which vary depending on your version of Windows:

    • Do you want Install to set up the DP4 environment? This installs the "DP4" database service in the Control Panel's list of services (Windows NT only) and defines the required environment variables in the registry editor.

    • Create DP4 group? or, from release 4.621 on computers with HTML Application support, a DP4 Start Menu dialog. This dialog allows you to choose a name for the DP4 gruop in the sart menu and how it is created. If you choose to create the DP4 start menu or DP4 group, icons for DP4 programs are placed in the start menu. You may copy icons to the desktop subsequently if you wish. Although you may be warned that this may take a long time, it is very unlikely to do so. The DP4 Start Menu dialog included with 4.621 arranges icons for DP4 into appropriate sub-menus and includes links to several new facilities.

    We recommend that you allow the install program to do both of the above because it takes more time to do these tasks yourself. You can still change your configuration later, as described in Configuration of DP4 on Windows.

  6. A window of information is displayed describing your installation. Read this carefully, checking that the installation matches your requirements, then click on the OK button to continue.

  7. The install program may then remind you that: "You must reboot your machine for the DP4 server to work correctly". In fact this message can usually be ignored unless you are installing on Windows 95/98/Me and want to run programs from a command prompt.

  8. If you chose to create a DP4 group, its window becomes active and displays the DP4 program icons.

  9. If you are installing DP4 for the first time, you should now follow the steps outlined in Configuration of DP4 on Windows to customise your DP4 installation as required.


Upgrading an Existing Installation

This section describes what work you need to do to prepare your Windows system to install a new DP4 for Windows release. So long as you are using the DP4 installation program, and were already running release 4.620 or above and are installing a later release of DP4 then you don't need to read this page because the install program will automatically perform the correct steps.

  1. If required preserve the existing printer and user information from your system current database as described in Preserving the System User List and Device Information. From release 4.621 the install program will follow this procedure automatically when the base DP4 set is upgraded.

  2. If you are running Windows NT or 2000, and are upgrading from 4.519/4.614 or earlier releases run srvw32 -uninstall to remove the "Datafit" service. It will be replaced by the DP4 System or DP4 Enterprise service, and will not be removable once you have upgraded, except by using regedit

  3. (This step is only necessary if you are upgrading from a pre 4.519 version of DP4). Delete the following DP4 files in the Windows directory, usually called C:\WINNT35, C:\WINNT40, C:\WIN95 or C:\WINDOWS:

    • WIN1632W.W32
    • WIN1632D.W32
    • SYSLIBT.DLL
    • SYSLIBW.DLL
    • USRLIBT.DLL
    • USRLIBW.DLL

    The replacements are now installed in the same directory as the DP4 32-bit Windows programs, usually C:\DP4\WIN

  4. The DP4 configuration files DATAFIT.INI and MAPEDIT.INI are the only DP4 files that may need to be located in the Windows directory and may be replaced during the installation. You may wish to keep your old INI files if you have made changes to them. If you do:

    1. Rename them before running the installation program
    2. Delete any lines from the DATAFIT.INI [startup] section that load the 16-bit interface program WIN1632W.EXE

    3. If you are installing 4.619 or earlier releases rename the files back to their original names when the installation has been completed. If you are installing a later release you cannot safely revert to the original versions of these files.

    From release 4.621 you can configure the name and location of DP4.INI. This is described in the Guide to DP4 configuration here.

    Please note that the contents of the DP4 configuration file change somewhat with each new release of DP4. Therefore it may be advisable instead to keep the new version of the file, and to remake any changes you have made from the issued copy of the file.From release 4.621 the install program uses the file dp4ini.inf on the DP4 CD-ROM to upgrade a DP4.INI file from an earlier release to the appropriate DP4 release.

  5. Run the DP4 Install Program as described earlier in Installing DP4 for 32-bit or 64-bit Windows using DP4 Install


Preserving the System User List and Device Information

Before you begin you may wish to create a backup copy of your current DP4 installation, so that you can revert to it if necessary.

From release 4.621 the install program will automatically preserve information from the system database when upgrading a previous DP4 installation. It does this by automatically following the second variant of the procedure descibed below. Up to release 4.620 you need to follow this procedure manually.

To preserve information from the system database proceed as follows:

  1. Export the User list from the existing system database. This is the list of users and their passwords as set up using MENUUSER.

    Run MENUEDIT -DB SYSTEM
    • Select Users table
    • Select Print user list

    • Print the user list to a file, so that you can re-load the information when the new system is loaded

    From release 4.621 the command menuedit -users -print -file filename will export the user list to filename without user intervention and then exit menuedit.

  2. You must export the Device setup from the existing system database. This is the set of printers and devices (and logical devices) set up using DFSETUP. Run DFSETUP
    • Select Printer characteristics
    • Select Export device information

    • Print the device information to a file

    From release 4.621 the command dfsetup -export -file filename will export the device list without user intervention and then exit dfsetup.

  3. Run the install program (see Installing Additional Products ) and:

    • Install the "Windows Programs" in the same directory as before, for example, C:\DP4\WIN

    • Install the "System database" product in the existing database directory, for example, C:\DP4\DB

  4. Re-load the user list

    Specify the filename you used for step 1 above in place of users.prn:

    MAPPOST -DB SYSTEM -quiet users.prn

  5. Re-load the device information. Specify the filename you used for step 2 above in place of devices.prn:

    MAPPOST -DB SYSTEM -quiet devices.prn

    If you like you can combine the previous two steps by specifying both filenames on the same command line:
    MAPPOST -DB SYSTEM -quiet users.prn devices.prn

If you are upgrading from quite an old version of DP4 it may be the case that some of the standard print devices have changed and should not be preserved. In this case you need to follow a slightly different procedure after step 4

  5. Repeat step 2 above to export devices from the new system database. Use a different filename from before.

  6. run MAPPOST -DB SYSTEM -overwrite -quiet devold.prn devnew.prn
    where devnew.prn is the filename you used to save the print devices from the new system database, and devold.prn is the name you used to save devices from the original system database.

This will ensure that any "standard" devices will be defined as issued by Itim.


Installing Additional Products

After you have installed the base system, you may re-run the install program at any time to install additional products, such as the C programming libraries. The DP4 Products Setup window that appears when a DP4 installation is detected by the Install program allows you to update your existing base DP4 installation by selecting the appropropriate product(s) as described in Installing DP4 Using the DP4 Install Program.

Remember that the DP4 Products Setup window only appears if the install program detects an existing, operational DP4 installation.

To install products:

  1. Insert the DP4 issue CD-ROM into the CD-ROM drive, or if you are installing directly from a Zip file downloaded from the DP4 web site, unzip the files into a remporary directory and start the setup program. (Some Zip utilities will do this automatically if you try to run the setup program from the Zip file). It is a good idea to unzip both the Zip file for the release of DP4 you want to install and the Documenation Zip file into the same directory, otherwise the install program won't be able to install the documentation for you. Select the appropriate install program using either the initial HTML applcation screen to select your desired DP4 release, or, for CD ROMs issued prior to Feb 2004, right click on the CD-ROM icon and run the appropriate install program.

  2. Read the information displayed in the DP4 Windows Installation screen, then Click on the Install button to continue,

  3. The DP4 Products Installation window appears, listing the available products. The user interface for this is slightly different depending on the release of DP4 being installed.

Releases up to 4.620

You can use various buttons contained in the window as follows:

Add >> | Adds a product to the Products to install list
Remove << | Removes a product from the Products to install list
Add All | Adds all products shown in the left hand window to the Products to install list in the right hand window.
Install | Installs the products added to the Products to install list
Cancel | Returns you to the initial install window, without installing any products

The install program does not allow you to select which sub-components of products to install, nor select an install location at this point. Instead, as each sub-component is installed you will be prompted for a directory name, and given an option to skip optional components.

The remaining steps in this procedure install the Base Dictionary database and illustrate how to install a product. You should, of course, install the products appropriate to your requirements in the same way.

  4. Highlight "Base Dictionary database", click on Add >> followed by Install. If a dialog box appears, type the directory into which you want to install the product.

  5. When all the programs have been copied, the install program informs you that the selected products, in this case the Base Dictionary database, are successfully installed. Click on OK to return to Windows. If you are returned to the Welcome screen again and there is no Close button, choose Abort - the installation will not cancelled or rolled back.

Release 4.621 and onwards

  4. You can use various buttons contained in the window as follows:

    Checkboxes

    Select whether to install a component or not. A dimmed checkbox indicates the product will only be partilaly installed because one or more optional components is not selected. If you are installing from a downloaded ZIP file, and you have not downloaded the DP4 documentation then you MUST clear the checkbox for DP4 documentation, otherwise the installation will fail.

    Select All

    Select all products and all optional components.

    Change...

    Opens a dialog allowing you to change where the product will be installed. This button is greyed out unless the product is selected for installation. Note that it may also be possible to select a separate install location for one or more optional components.

    Details...

    Opens a dialog very similar to the products window allowing you to select which optional components can be installed. This button is greyed out unless the product has one or more optional components, or more than one component for which an install location can be specified.

    Install

    Installs the products marked with a checkbox.

    Cancel

    Returns you to the initial install window, without installing any products

    Once you click on the install button, all the products and components you have selected will be installed without further ado - you will not be prompted with any dialogs to skip components or change locations.

  5. When installation has completed the installer may perform one or more supplementary tasks, such as modiying the start menu. From 4.621 this is done using separate applications. These application will contain any necessary help information on screen.


Installing 32-bit DP4

Appendix A - Installing 32-bit DP4 Manually

  1. If you are running on Windows NT based operating system make sure you are logged on as a user with administrator rights on the local machine.

  2. On Windows 95,98,Me edit the AUTOEXEC.BAT file as follows:

    If you are installing 4.619 or earlier define the DATAFIT environment variable:

    set DATAFIT=licence_file)directory

    and,optionally:

    path other_directories;DP4_programs

    where licence_file_directory and DP4_programs are the locations on your system of the DP4 licence file and the DP4 executables respectively. It is suggested that you store the DP4 licence file in the same directory as your DP4 programs, as this makes it easier to install and run multiple versions of DP4. It is not strictly necessary to set the path to include the location of DP4 programs. The DATAFIT environment variable is not used in DP4 Enterprise (4.620 or later) and it is no longer necessary to set it.

  3. Create the required directory structure.

  4. From the supplied disk, copy the DP4 licence file, DP4.SYS or DATAFIT.SYS, to the appropriate directory. (See Names and Locations of Configuration files to decide what this should be).

  5. Copy the Windows programs to their directory. Copy *.SYS,*.EXE, *.DLL, *.W32,*.BMP, *.RWL, and *.FON to leave files only used by the installer on the CD-ROM. From release 4.621 if you want to use any of the new configuration helper programs you also need to copy files with the following extensions: .HTM,.HTC,.HTA,.JS,.CSS to the same directory. Copy the DP4 configuration files to the appropriate directory. If you are installing versions up to 4.619 Copy DATAFIT.INI and (for 4.6xx) MAPEDIT.INI into the Windows directory, which is usually called C:\WINNT35 or C:\WIN95 or C:\WINDOWS. If you are installing DP4 Enterprise the DP4.INI and MAPEDIT.INI files should be copied into the same diretory as the .EXE and .DLL files, and not the Windows directory.

  6. If you are installing on Windows 95 and are installing 4.622 or later then copy the file dbmslb95.dll over dbmslibt.dll, because otherwise DP4 will not run. This step is not necessary on Windows 98 or Windows Me.

  7. If you are installing on Windows NT or Windows 2000 or later, from the Start Menu, Program Manager, or a command prompt run the following command:

    c:\dp4\win\srvw32 -install

    Replace c:\dp4\win with the directory where you installed the DP4 programs. This creates the DP4 System service. This step can be skipped if the DP4 system will always be loaded as an application (this requires you to change the loader entry of the DP4 configuration file). If you want to customise the name of the DP4 system service refer to the information on branding in the Guide to DP4 configuration.

  8. On Windows NT from within the Control Panel's list of services start the DP4 System or DP4 Enterprise service. (This step is optional as the DP4 service will normally be started automatically when you run a DP4 program). You may wish to change the startup properties of the DP4 service to allow it to interact with the desktop (this is already set automatically when installing DP4 Enterprise).

  9. (Optional). From release 4.621, you can run DP4.HTA to add entries for DP4 to the Windows start menu. There are also HTAs for setting up Message Manager, and the DP4 help files.

  10. (Optional, because you have already installed a userdata.sys file at step 5) Run the USERDATA program to create a USERDATA.SYS file as described in Creating USERDATA.SYS.

  11. From the Start Menu, Program Manager, or a command prompt run the following command:

    c:\dp4\winnt\dbrestor -system -disk d:\xxx\win32\

    Replacing d: with the drive letter of your CD ROM drive, and xxx with the minor version number of DP4 you are installing e.g. 617 or 521.

    Follow the instructions displayed by dbrestor to install the System database. If you are using your original licence disk the System database will be installed in the same directory as your DP4 programs, because the database locations ahve not yet been set up.

    Alternatively, simply copy a system database from another installation if you have customised the system database.

  12. From the Start Menu, Program Manager, or a command prompt run the following command:

    c:\dp4\win\dfsetup

    and complete the DP4 configuration (see Running DFSETUP to Configure DP4).

  13. If necessary, move the system database (SYSTEM.DAT, SYSTEM.IND, and from release 4.622 SYSTEM.DCI and SYSTEM.PTR) to the new locations for .DAT and .IND files. If you do this you should stop the DP4 service with the following command:

    srvw32 -stop

  14. From the Start Menu select Settings/Task Bar/Start Menu Programs and set up Program Items as required by typing a description and then the full pathname of the executable program at the command line.

    The programs that you include as icons in the DP4 group or in the Start Menu will depend on your requirements but as an example, a minimum set might include:

    • dfsetup.exe
    • dp4.exe
    • dbrecov.exe

    • srvw32 -stop

  15. Restore the Base Dictionary database using DBRESTOR.


Installing DP4 on Citrix Servers

Installing DP4 on Citrix Servers or NT Terminal Server Edition

The standard DP4 32-bit windows set runs on the various Citrix products (Winframe or Metaframe) and on Windows Servers with Terminal Services installed. However some additional steps may be necessary compared with installation of DP4 on regular Windows.

  • Introduction
  • Installation
  • Configuration


Introduction

DP4 is designed to run as a service on Windows NT and 2000, NT Terminal Server Edition, Windows 2000 Terminal Services Clients, and servers using Citrix products such as WinFrame or MetaFrame. The installation procedure installs the DP4 service. The service provides the database manager and, optionally, other components such as the network manager - if DP4 network clients are to be used (You do not need the network manager for accessing DP4 via Terminal Server or Citrix clients). DP4 applications and utilities run on a WinFrame or Terminal Server client can access the database manager directly as for stand alone operation. They do this by means of a system of shared memory and semaphores to pass data to and from the database manager. These regions of shared memory and semaphores are created by DP4 servers when they start up, the code to do this is in a DLL, SYSLIBT.DLL. Under regular Windows NT these areas of shared memory and semaphores are immediately accessible to applications for use. This is not so under WinFrame or a Terminal Server, where they are private to the service which created them. For applications to communicate directly with the database manager as opposed to via a DP4 network connection it is necessary to mark SYSLIBT.DLL as being global to the system. This can be done using the register command.

On Windows 2000 or later systemss the register command appears not to work. Instead SYSLIBT.DLL automatically detects that it is running on Windows 2000, and creates the shared objects in a different way that ensures they are global to the system.

If you are installing release 4.619 or earlier of DP4 on Windows NT Terminal Server or Citrix, Installation should be performed in the special "install mode". This ensures that the system will give each client its own copy of the datafit.ini file.


Installation

These notes were created for Citrix WinFrame 1.6, and may not apply to later Citrix products. If you find that the special instructions here don't work on your machine, then you probably do not need to worry, unless you are trying to install a pre 4.620 version of DP4.

Before installing DP4 on WinFrame read the notes on "General Installation of Applications on WinFrame". These notes can be found in the WinFrame for Networks Help System/Application Notes. You can access the help system by double clicking the WinFrame Help icon in the Main program group.

  1. Open a command prompt

  2. Switch the server to install mode using the change user /install command

  3. Run the DP4 install procedure, as for regular Windows NT

  4. Switch the server back to execute mode using change user /execute

  5. To make the service accessible to the WinFrame clients, switch to the directory where the DP4 executables are located and run register syslibt.dll /system. This step is not necessary to run Windows 2000 Terminal Services clients. However in that case you require a version of syslibt.dll dated 7 Jun 2001 or later.

The DP4 system is now installed and ready for use.


Configuration

See the notes about .INI file mappings in the General Installation of Applications on WinFrame.

  1. DP4 applications make use of the DP4 configuration file. Provided the above procedures have been followed, a copy of the configuration file will be copied to the Windows sub-directory of the user's home directory, allowing each user to have his own settings.

  2. It is possible for each user to have their own copy of USERDATA.SYS. By default the copy of USERDATA.SYS in the installation directory is used by all users. However if a copy of USERDATA.SYS is placed in the users home directory and this is the current directory when the application is launched, the application will use this copy instead. One way to do this is to set the working directory for each DP4 program in the group to %homedrive%%homepath%. This should be done in "install" mode.


Configuration of DP4 on Windows

This section introduces some of the key features of your DP4 configuration and describes how to customise your DP4 installation. It introduces:

  • The DP4 licence file
  • The PATH environment variable
  • Starting and Stopping the DP4 System Service
  • Creating the DP4 terminal configuration file, USERDATA.SYS
  • Running the DP4 utility DFSETUP to configure DP4
  • Using the DP4 configuration file to control the operation of DP4 under 32-bit Windows

Most of these topics are covered in greater detail in the Guide to DP4 Configuration.


DP4 Licence File

The DP4 licence file, DP4.SYS or DATAFIT.SYS, includes the name of your organisation and your licence serial number. It also includes the location of the database files and most importantly the name and location of the SYSTEM database.

The DP4 Install program will ask you to supply a copy of this file when DP4 is first installed, and will create a copy of the file with the database file locations filled in in the appropriate location on your machine. However, it does not fill in the location for other files that will be created/used when you run DP4 programs. You set this information up using DFSETUP as described in Running DFSETUP to Configure DP4.

In 32-bit and 64-bit Windows, the DP4 licence file normally resides in the same directory as the DP4 programs. If you change the location of the DP4 licence file, and are using 4.619 or an earlier release of DP4, you must modify the value of the DATAFIT environment variable.

In later releases of DP4 if the DP4 licence file is not stored in the directory containing SYSLIBT.DLL you must specify a value for the dp4home entry in the appropriate section of the DP4 configuration file as described here. It is strongly recommended that you do not do this.


DATAFIT Environment Variable

This page applies only to releases of DP4 up to 4.619, and to the 16-bit version of DP4 for Windows for Windows 3.x. In later releases the DATAFIT environment variable is not used by any standard DP4 components, and the licence file is located by other means. See Names and Locations of Configuration files in the Guide to DP4 Configuration for details.

Windows NT/2000

The environment variable DATAFIT points to the directory that holds the DP4 licence file. It is automatically defined, during installation with DP4 Install, as the directory in which you installed the DP4 programs (assuming you answer Yes to the question about setting up the DP4 environment).

You must respecify the DATAFIT environment variable if you change the location of the DP4 licence file, as follows:

  • run srvw32 -install, if you have moved both SRVW32.EXE and the DP4 licence file, and they are both still in the same directory.
or

  1. From the Control Panel, double-click the System icon. The System dialog appears.

  2. In the System Environment Variables box (the location of this varies depending on the version of Windows), locate and click the line that specifies the DATAFIT environment variable.

    Towards the bottom of the dialog, the Variable box displays DATAFIT and the Value box displays the old location of the DP4 licence file, such as, "C:\DP4\WIN".

  3. In the Value box, edit the directory definition of DATAFIT to match its new location.

  4. Click Set to make the change in your environment (you do not need to reboot your machine) and OK to exit from the System dialog.

Windows 3.x,95/98/Me

The DP4 Install program sets the DATAFIT environment variable up for you. The following is provided for the benefit of those installing manually or wishing to check the DP4 Install worked as expected.

You must include a line in AUTOEXEC.BAT to set the environment variable DATAFIT to the directory in which the DP4 licence file resides, for example:

@SET DATAFIT=C:\DP4\WIN\

If you start DP4 programs from a command prompt you can change the DATAFIT environment variable from another batch file first, for example if you have multiple versions of DP4 installed. However programs started from Explorer will always use the original value of DATAFIT. There is a program called WINSET, supplied with the Windows 95 Resource Kit, that can be used to change the environment used by Explorer.

If you are installing a 16 bit version of DP4 for release 4.620 or later, DP4 uses DP4HOME instead of DATAFIT.


Setting the PATH variable

The DP4 installation program does not add the location of DP4 programs to the path, as this is not required for running from the Start Menu. However you may find it useful to add the location of DP4 programs to the path.

Windows NT and 2000

DP4 programs are run just by clicking their icons. To be able to run them from the Run option of the File or Start menu without including the full pathname, set the PATH environment variable as follows:

  1. From the Control Panel, double-click the System icon. The System dialog appears
  2. In the System Environment Variables box, locate and click the line that specifies the PATH environment variable. Towards the bottom of the dialog, the Variable box displays PATH and the Value box displays the PATH's search list
  3. In the Value box, edit the search list to include the DP4 program directory, which is "C:\DP4\WIN", assuming you accepted the default installation directory
  4. Click Set to make the change in your environment (you do not need to reboot your machine) and OK to exit from the System dialog

Windows 95,98,Me

Using a text editor, add the directory containing the DP4 Windows programs to the PATH defined in your AUTOEXEC.BAT file. If you accepted the default directory assignment for the Windows programs, the PATH statement takes the form:

path other_directories;c:\dp4\win

After changing AUTOEXEC.BAT you must restart your PC for the changes to take effect, except when running from a command prompt. However there is a utility called WINSET which can be used to change the master environment. This is available in the Windows 95 Resource Kit.

On Windows Me AUTOEXEC.BAT is not used (unless you hack the operating system), but if you edit AUTOEXEC.BAT the changes are put into the registry. Simply copying on a new copy of AUTOEXEC.BAT may not work.


Starting and Stopping the DP4 System Service

The DP4 System components vary according to how you configure your system. For example you may choose to access DP4 databases remotely via TCP/IP networking, or to enable such access to your local database for other users. This topic is briefly introduced in Customising StartUp.

No matter what components are loaded as part of the DP4 service you will use essentially the same techniques to start and stop the DP4 system. However the details differ according to the version of Windows in use.

Windows NT, 2000, and XP or later

A Windows database manager called DP4SRVR.W32 or DP4SRVR.W64 is provided as standard in the base system installation. It is loaded and unloaded when the DP4 System or DP4 Enterprise service is started and stopped.

DP4 System (to 4.619) or DP4 Enterprise(from 4.620) should appear in the list of services in the Windows NT Control Panel (but see the information on branding in the Guide to DP4 configuration for how to change the name of this service). This service, which usually runs DP4SRVR.W32, needs to be started before DP4 programs can run (though in normal operation DP4 programs will attempt to start the service if it is not already running). If the service is not listed refer to Installing DP4 as a Service.

By default, the startup type of the DP4 System service is Manual. Such services can be started and stopped by a user or dependent service:

  • To start the DP4 service, select it and click on the Start button
  • To stop the DP4 service, select it and click on the Stop button

You can change the DP4 service type to Automatic if you want it to start each time the system is booted. You should do this if the machine is intended to act as an unattended server for other DP4 users to access, or if you log on in an account that does not have the right to start and stop services manually.

To reconfigure how the DP4 service is started:

  1. Log on to a user account that has membership in the Administrators local group

  2. Navigate to the the Services option in Control Panel (in Windows 2000 and later this is inside the Administrative Tools applet)

  3. Click on the DP4 service to select it

  4. Click on the Startup button. Use the Service Startup dialog box to configure when and how the service is started and to specify the user account the service used to log on. (As with most services, DP4 logs on to the Local System account, and this should not usually be changed as it prevents the service interacting with the desktop)

    You may wish to enable the "allow service to interact with desktop" checkbox. This will allow the DP4 service to display an icon in the taskbar which you can use to access version information and to stop the DP4 service. This option is enabled by default if you run srvw32 −install with DP4 Enterprise.

One important point about "Manual" and "Automatic" services is that they are unaffected by users logging on and off.

The DP4 service can be started and stopped from the command line using srvw32 -start and srvw32 -stop (or srvw64 -start etc if you have installed the 64-bit version of DP4), but this requires local administrator rights prior to release 4.621. You can also start and stop Windows services using net start service_name and net stop service_name. The name of the DP4 service is usually dfsolutions .

The DP4 system can be run as an application rather than a service. You should consider doing this unless you require remote users to be able to access databases when no one is logged on. Whether it is run as an application or as a service depends on the command tails used to load it:

SRVW32 -LOAD | runs DP4 as an application
SRVW32 -START | runs DP4 as a service

You should use SRVW32 -UNLOAD to unload DP4 as an application and SRVW32 -STOP to stop it as a service.

SHUTDOWN -STOP and SHUTDOWN −NOREMAIN can also both be used to unload DP4.

Running the DP4 system as an application rather than a service has the following advantages:

  • You do not need administrator rights to stop and start the DP4 system. (On Windows 2000 "Power Users" can also start and stop services, including the DP4 system, though you will need 4.621 or later to able to start and stop the service with srvw32.exe -start/-stop)
  • You can access databases held on network drives. When run as a service the DP4 system cannot access network drives because the local system account is not allowed access to them.

Windows 95,98,Me

A 32-bit Windows database manager called DP4SRVR.W32 is provided as standard in the base system installation.

Running any DP4 programs will automatically load the DP4 system if it is not already running and place a DP4 icon in the "system tray" area of the task bar at the foot of the screen. To unload the DP4 server right-click on the DP4 button in the application bar and select Shutdown from the menu that appears.

To force the DP4 server to start automatically whenever Windows 95 is started:

  • In the StartUp folder (in Start Menu\Programs\) create a shortcut to the DP4 loader program SRVW32.EXE.

You can start the DP4 system manually under Windows 95 with any of the following commands: SRVW32, SRVW32 -LOAD, SRVW32 -START

These are currently equivalent, but in future SRVW32 -START may run DP4 in a way which causes it to survive a user log off and to be runnable before a log on (using the Windows 95 equivalent of NT services). The first command is not recommended as it does not work on Windows NT.

You can use use SRVW32 -UNLOAD or SRVW32 -STOP to stop DP4.

SHUTDOWN -STOP and SHUTDOWN −NOREMAIN can also both be used to unload DP4.

If you want the DP4 menu program to start automatically when Windows is started, in the StartUp folder create a shortcut to DP4.EXE.


Customising StartUp

The [startup] section of the DP4 configuration file contains the list of programs started when the DP4 service is started up.

1=[priority][Type] program_name_1 command tails
2=[priority][Type] program_name_2 command tails
3=[priority][Type] program_name_3 command tails
...

If no startup section is specified the startup section defaults to

1=dp4srvr.w32

Detailed information on the [startup] section of the DP4 configuration file, including details of the program types and priorities can be found here.

Example [preload] and [startup] sections

[preload]
1 = dp4srvr.w32
2 = *dbrecov -db dbname
3 = *dbcheck -db dbname -check -batch

[startup]
1 = tcpw.w32 -multiple -server 80
2 = dp4srvr.w32 -aux
3 = tcpmgr.w32 -server 80 -aux
4 = auxdistr.w32 -server 80 -use 80

It is necessary to start DP4SRVR as shown in the preload section, because it is not auto-loaded; note that it is unnecessary (and you are recommended not) to use SHUTDOWN to stop the stand-alone database manager at the end of the [preload] section before re-loading it with the networking components.

Alternative [startup] and [preload] sections

The loader program will look for different section names instead of [startup] and [preload] if it is started with the command tails

-startup startup_section_name

or

-preload preload_section_name

This allows the user to have multiple startup configurations in the DP4 configuration file and to select the one required without editing the file.

Loading Network Programs

Consult Overview of DP4 Networking Configurations in the Guide to DP4 Networking and Resilience(netres.chm) for full information on the various DP4 networking configurations. Consult Loading an ADC in the ADC Developer's Guide for full information on loading DP4 ADCs.

The following instructions will load a simple DP4 networking configuration using TCP/IP

To define the machine as a DP4 requester, add a section called [startup] to the DP4 configuration file, for example:

[startup]
1=tcpw.w32 -server_name computer name

computer name must be a name that the ping command recognises and which corresponds to the machine to be used as the DP4 server.

To define the machine as a DP4 server, specify a [startup] section of this form:

[startup]
1=dp4srvr.w32
2=tcpmgr.w32


Creating USERDATA.SYS

USERDATA.SYS contains information about your user interface settings. The file is created by running the USERDATA utility.

To run USERDATA:

  1. You can run USERDATA from its icon in the start menu. Usually it is better to use the Run Command, or start it from a command promopt: this will allow you to supply the -saa or -windows command tail to USERDATA (or any of the other command tails accepted by this program as documented here).

  2. Select the USERDATA type from the list displayed, by typing the corresponding letter

The DP4 install program installs a userdata.sys created with this command:
userdata -saa -reset -type c
or, from 4.619:
userdata -windows -reset -type c

  • A: Windows using DOS Font
  • B: Windows using System fixed font
  • C: Windows using System variable font
  • D: Windows using ANSI fixed font
  • E: Windows using ANSI variable font
  • F: Windows using font specified in the DP4 configuration file

Type A will maintain compatibility of accented characters for DP4 between MS-DOS and Windows. However for compatibility with other Windows software you should use one of the other fonts. (Types B through E all use the native Windows character set). Type B will give the best results for DP4 systems that were originally text based.

As soon as you select the font type userdata.sys is created in the current directory, unless you choose type F in which case you first must choose one of the other fonts available on your system using the usual Windows Font Picker Dialog.

It is possible for the DP4 configuration file to completely over-ride the font specified in userdata.sys file, even when one of types A through E is chosen, using the forcefont setting. (The DP4 Configuration file is explained in the Guide to DP4 Configuration. From release 4.623 you can also give DP4 programs their own private copies of the userdata.sys file to allow them to use custom settings.

Selecting the font type results in the automatic creation of USERDATA.SYS in the directory specified as the working directory for USERDATA. If you allowed the install program to create the "DP4" group, the working directory is the directory in which you installed the DP4 Windows programs, for example: C:\DP4\WIN. To see the working directory check the properties of the USERDATA short-cut.

On start up, DP4 attempts to locate a USERDATA.SYS file by searching directories in this order:

  • The DP4 program's working directory
  • The directory in which the DP4 licence file resides


Running DFSETUP to Configure DP4 (32-bit)

Running DFSETUP to Configure DP4

You run the DFSETUP utility to configure various aspects of DP4 operation such as the location of the different classes of DP4 file, console and transaction logging options, user preferences, printer usage, and support for terminal operation (e.g. in a Telnet session). For more details see DFSETUP in the Guide to DP4 configuration.

Assigning Directories

DP4 uses several different file types for which no explicit location is assigned by the Install program. Such files are created in the current or working directory for the program unless you assign an explicit location. Do this as follows:

  1. Start DFSETUP (from the start menu, or a command prompt, or from the DP4 menu)
  2. Select Directory assignment;
  3. The directory assignments are at your discretion, though it is suggested that you keep all files in sub directories of the base directory for your DP4 installation, perhaps like this:
Data,index,rollback and log files in | C:\DP4\DB
Backup files in | C:\DP4\BKP
Spooler files,console log files, and print files in | C:\DP4\PRINT
Work and Extract files in | C:\DP4\TMP


The DP4 configuration file

The DP4 configuration file controls many aspects of DP4 operation:

  • The [trmw] section, or equivalent named sections for individual programs control the appearance, size and position of DP4 program windows.

  • Except for the legacy 16-bit version of bit DP4, the [startup] and [preload] sections control how the DP4 service is started and what programs are run as part of the DP4 service and database manager. For further information and example configurations see Customising Startup.

  • Other sections are used to turn diagnostic output on or off in various programs, interface DP4 with Oracle or other OEM databases, provide localised versions of various messages, and many other purposes.

For full information on the DP4 configuration file refer to the Guide to DP4 configuration. (DFIni.chm)


Installing DP4 as a Service

DP4 is installed a service by the DP4 install program if you answer Yes to "Do you want Install to set up the DP4 environment?". The Install Program does this by running srvw32 -install. You can use this command at any time yourself to:

  • (Up to 4.619 only) Define the environment variable for the DP4 licence file as described in DATAFIT Environment Variable.

  • Add the service for running DP4 to the list of the control panel's services. This service runs the DP4 loader program srvw32.exe, which in turn starts the programs run as part of the DP4 service such as DP4SRVR.W32 and TCPMGR.W32.

On Windows NT based operating systems you will need to do this if you move your DP4 installation to a new directory, or you want to change the name of the DP4 service.

You can remove the DP4 service from the control panel, and (up to 4.619 only) undefine the environment variable by running:

srvw32 -uninstall

Both these commands require you to be logged on using an account with local administrator rights.


Preparing to Run DP4 for Windows and MS-DOS

There is more than one way of running the MS-DOS and Windows versions of DP4 alongside one another, but the method we recommend uses this directory structure:

C:\DP4\DOS | DP4 MS-DOS programs, DP4 licence file for MS-DOS (System database specified as: SYSTEM) and USERDATA.SYS
C:\DP4\WIN | DP4 Windows programs, DP4 licence file for Windows (System database specified as: SYSWIN) and USERDATA.SYS
C:\DP4\DB | Database data files including the System databases for MS-DOS, SYSTEM, and Windows, renamed SYSWIN, plus the Base Dictionary, BD)

To prepare your system in line with the above scheme:

  1. Go to the database directory and save the DOS system database under a name other than "system". For example:

    CD C:\DP4\DB
    RENAME SYSTEM.* SYSDOS.*

    This preserves the MS-DOS system database when installing the Windows system database, which is initially called "system"

  2. Go to the directory holding your existing DP4 licence file and save it under a different name. For example:

    CD C:\DP4
    COPY DATAFIT.SYS SAVEDATA.SYS

    This assumes your existing MS-DOS DP4 installation is for release 4.523 or earlier. In later releases the licence file is called dp4.sys.

  3. Modify the licence file so that it is suitable for use with Windows by setting the name of the Windows system database (which is not yet installed). For example:

    SYSDB SYSWIN

  4. Create a directory for the DP4 Windows programs. For example:

    MD C:\DP4\WIN

  5. Copy the modified licence file into that directory

  6. Return to the directory holding SAVEDATA.SYS, rename it to back to its original name, use SYSDB to specify the system database as SYSDOS and copy the licence file to the DP4 MS-DOS programs directory

  7. Your MS-DOS system must be operational for the install program to present the correct type of installation. So, check that it is by running any DP4 program.

  8. Run the install program (see Installing Additional Products ) and:

    • Install the "Windows Programs" product in a separate directory to the MS-DOS programs, called, for example, C:\DP4\WIN

    • Install the "System database" product in the existing database directory, for example, C:\DP4\DB

    Rename the Windows System database to SYSWIN, for example:

    CD C:\DP4\DB
    RENAME SYSTEM.* SYSWIN.*

  9. Rename the MS-DOS System database to SYSTEM, for example:

    RENAME SYSDOS.* SYSTEM.*

To switch between MS-DOS and Windows versions, change the PATH specified for the DP4 programs and set the DP4 environment variable to locate the appropriate licence. You could automate this with a batch file of the form:

if "%1"=="d" goto setdos
if "%1"=="w" goto setwin
:setdos
set path=c:\dp4\dos;%oldpath%
set DATAFIT=c:\dp4\dos
goto end
:setwin
set path=c:\dp4\win;%oldpath%
set DATAFIT=c:\dp4\win
goto end
:end

If you are using a post 4.523/4.619 release of dp4 the DATAFIT environment variable should be replaced by DP4HOME.

The batch file above relies on the inclusion of the following line below the PATH statement in AUTOEXEC.BAT:

set oldpath=%path%

At the time this variable is set no directory for DP4 executables should be in the path.

Once all the software has been installed and configured, you would type "<batch_filename> w" before running the Windows version and "<batch_filename> d" before running the MS-DOS version.


The 16 Bit Windows Database Manager

The 16 Bit Windows version of the DP4 database manager is called SRVW.EXE.

You must load SRVW.EXE (or a DP4 network requester) from within Windows before running DP4 programs (though from release 4.519 DP4 programs may be able to start SRVW if it is not already running). We recommend that you make use of the Windows "StartUp" group to do this. Programs included in this group are executed each time you run Windows.

SRVW does not support the running of MS-DOS DP4 programs in a 'DOS box' - if you want to run a mixture of MS-DOS and Windows programs you have to use the Win32 version of DP4.

Using Command Tails with SRVW

You can apply command tails to SRVW by specifying them as part of the command line when it is installed in Windows. Unlike SRV2, it does not read additional command tails from the environment, but instead it looks in the DP4 configuration file for the lines:

[srvw]
srvw = -<command_tail_1> -<command_tail_2> ...

The command tail -REMAIN is not implemented. Once loaded, SRVW appears as an icon and remains in memory until it is shut down by the user. The command tail -NOREMAIN is implemented instead to provide 'one-off' operation with automatic unloading after use.